-module(calc3).

-export([start/0, add/2, mult/2]).

start() ->
    % Register the service instead of returning it
    register(calcservice, spawn(fun loop/0)).
        
add(A, B) ->
    % I find the calc service that was previously registered, so the caller
    % doesn't have to tell me about it anymore.
    Calc = whereis(calcservice),
    Calc ! {self(), add, A, B},
    receive
        {Calc, Result} -> Result
    end.

mult(A, B) ->
    Calc = whereis(calcservice),
    Calc ! {self(), mult, A, B},
    receive
        {Calc, Result} -> Result
    end.


loop() ->
    receive
        {Sender, add, A, B} -> 
            Result = A + B,
            io:format("adding: ~p~n", [Result]),
            Sender ! {self(), Result},
            loop();
        {Sender, mult, A, B} -> 
            Result = A * B,
            io:format("multiplying: ~p~n", [Result]),
            Sender ! {self(), Result},
            loop();
        Other -> 
            % I catch this case here - the process is now publicly registered,
            % so it's possible that I receive unknown messages.
            io:format("I don't know how to do ~p~n", [Other]),
            loop()
    end.
