-module(myserver).
-behavior(gen_server).

-export([start_link/0, print_state/0]).

-export([init/1, handle_call/3, handle_cast/2, handle_info/2, terminate/2, code_change/3]).

start_link() ->
    gen_server:start_link({local, ?MODULE}, ?MODULE, [], []).
    
print_state() ->
    gen_server:call(?MODULE, print_state).
    
init([]) ->
    {ok, 0}.
    
handle_call(print_state, _From, State) ->
    io:format("Current state: ~p~n", [State]), 
    {reply, ok, State + 1};
    
handle_call(_Call, _From, State) ->
    {noreply, State}.

handle_cast(_Cast, State) ->
    {noreply, State}.
    
handle_info(_Info, State) ->
    {noreply, State}.
    
terminate(_Reason, _State) -> ok.

code_change(_OldVsn, State, _Extra) ->
    {ok, State}.