import Control.Concurrent
import Control.Concurrent.STM
import Control.Monad (forever)

waitAndOutput :: (Show a) => TVar a -> IO ()
waitAndOutput tv = do
	threadDelay(500000)
	val <- atomically (readTVar tv)
	putStrLn("Current value: " ++ show val)
	
incrementVal :: (Num a) => TVar a -> STM ()
incrementVal tv = do
	currentval <- readTVar tv
	writeTVar tv (currentval + 1)

secondThread :: (Num a) => TVar a -> IO ()
secondThread tv = do
	threadDelay(2000000)
	atomically (incrementVal tv)
	putStrLn("Second thread incremented shared value")
	
main = do
	tvar <- atomically (newTVar 1)
	forkIO(forever (secondThread tvar))
	forever (waitAndOutput tvar)
